import java.util.LinkedList;
import java.util.Queue;

public class BinaryTreeTraversals {
    
    public static void printPreOrder(BinaryTreeNode<String> node) {
        if (node == null) {
            return;
        }
        System.out.print(node.getData());
        printPreOrder(node.getLeft());
        printPreOrder(node.getRight());
    }

    public static void printPostOrder(BinaryTreeNode<String> node) {
        if (node == null) {
            return;
        }
        printPostOrder(node.getLeft());
        printPostOrder(node.getRight());
        System.out.print(node.getData());
    }

    public static void printInOrder(BinaryTreeNode<String> node) {
        if (node == null) {
            return;
        }
        printInOrder(node.getLeft());
        System.out.print(node.getData());
        printInOrder(node.getRight());
    }

    public static void printLevelOrder(BinaryTreeNode<String> node) {
        if (node == null) {
            return;
        }
        Queue<BinaryTreeNode<String>> q = new LinkedList<>();
        q.add(node);
        while (!q.isEmpty()) {
            BinaryTreeNode<String> next = q.remove();
            System.out.print(next.getData());
            if (next.getLeft() != null) {
                q.add(next.getLeft());
            }
            if (next.getRight() != null) {
                q.add(next.getRight());
            }
        }
    }

    public static void main(String[] args) {
        BinaryTreeNode<String> two = new BinaryTreeNode<>("2");
        BinaryTreeNode<String> three = new BinaryTreeNode<>("3");
        BinaryTreeNode<String> seven = new BinaryTreeNode<>("7");
        BinaryTreeNode<String> expr = new BinaryTreeNode<>("+", 
            new BinaryTreeNode<String>("*", two, three), seven);
        
        printPreOrder(expr);
        System.out.println();
        printInOrder(expr);
        System.out.println();
        printPostOrder(expr);
        System.out.println();
        printLevelOrder(expr);
        System.out.println();
    }
}
